package com.mvc.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TAppComlogExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TAppComlogExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNull() {
            addCriterion("STATION_CODE is null");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNotNull() {
            addCriterion("STATION_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andStationCodeEqualTo(String value) {
            addCriterion("STATION_CODE =", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotEqualTo(String value) {
            addCriterion("STATION_CODE <>", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThan(String value) {
            addCriterion("STATION_CODE >", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CODE >=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThan(String value) {
            addCriterion("STATION_CODE <", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThanOrEqualTo(String value) {
            addCriterion("STATION_CODE <=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLike(String value) {
            addCriterion("STATION_CODE like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotLike(String value) {
            addCriterion("STATION_CODE not like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeIn(List<String> values) {
            addCriterion("STATION_CODE in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotIn(List<String> values) {
            addCriterion("STATION_CODE not in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeBetween(String value1, String value2) {
            addCriterion("STATION_CODE between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotBetween(String value1, String value2) {
            addCriterion("STATION_CODE not between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdIsNull() {
            addCriterion("APP_LOGIN_ID is null");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdIsNotNull() {
            addCriterion("APP_LOGIN_ID is not null");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdEqualTo(String value) {
            addCriterion("APP_LOGIN_ID =", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdNotEqualTo(String value) {
            addCriterion("APP_LOGIN_ID <>", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdGreaterThan(String value) {
            addCriterion("APP_LOGIN_ID >", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdGreaterThanOrEqualTo(String value) {
            addCriterion("APP_LOGIN_ID >=", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdLessThan(String value) {
            addCriterion("APP_LOGIN_ID <", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdLessThanOrEqualTo(String value) {
            addCriterion("APP_LOGIN_ID <=", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdLike(String value) {
            addCriterion("APP_LOGIN_ID like", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdNotLike(String value) {
            addCriterion("APP_LOGIN_ID not like", value, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdIn(List<String> values) {
            addCriterion("APP_LOGIN_ID in", values, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdNotIn(List<String> values) {
            addCriterion("APP_LOGIN_ID not in", values, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdBetween(String value1, String value2) {
            addCriterion("APP_LOGIN_ID between", value1, value2, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andAppLoginIdNotBetween(String value1, String value2) {
            addCriterion("APP_LOGIN_ID not between", value1, value2, "appLoginId");
            return (Criteria) this;
        }

        public Criteria andMemoIsNull() {
            addCriterion("MEMO is null");
            return (Criteria) this;
        }

        public Criteria andMemoIsNotNull() {
            addCriterion("MEMO is not null");
            return (Criteria) this;
        }

        public Criteria andMemoEqualTo(String value) {
            addCriterion("MEMO =", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoNotEqualTo(String value) {
            addCriterion("MEMO <>", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoGreaterThan(String value) {
            addCriterion("MEMO >", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoGreaterThanOrEqualTo(String value) {
            addCriterion("MEMO >=", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoLessThan(String value) {
            addCriterion("MEMO <", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoLessThanOrEqualTo(String value) {
            addCriterion("MEMO <=", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoLike(String value) {
            addCriterion("MEMO like", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoNotLike(String value) {
            addCriterion("MEMO not like", value, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoIn(List<String> values) {
            addCriterion("MEMO in", values, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoNotIn(List<String> values) {
            addCriterion("MEMO not in", values, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoBetween(String value1, String value2) {
            addCriterion("MEMO between", value1, value2, "memo");
            return (Criteria) this;
        }

        public Criteria andMemoNotBetween(String value1, String value2) {
            addCriterion("MEMO not between", value1, value2, "memo");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andLogTypeIsNull() {
            addCriterion("LOG_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andLogTypeIsNotNull() {
            addCriterion("LOG_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andLogTypeEqualTo(String value) {
            addCriterion("LOG_TYPE =", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotEqualTo(String value) {
            addCriterion("LOG_TYPE <>", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeGreaterThan(String value) {
            addCriterion("LOG_TYPE >", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeGreaterThanOrEqualTo(String value) {
            addCriterion("LOG_TYPE >=", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLessThan(String value) {
            addCriterion("LOG_TYPE <", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLessThanOrEqualTo(String value) {
            addCriterion("LOG_TYPE <=", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLike(String value) {
            addCriterion("LOG_TYPE like", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotLike(String value) {
            addCriterion("LOG_TYPE not like", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeIn(List<String> values) {
            addCriterion("LOG_TYPE in", values, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotIn(List<String> values) {
            addCriterion("LOG_TYPE not in", values, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeBetween(String value1, String value2) {
            addCriterion("LOG_TYPE between", value1, value2, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotBetween(String value1, String value2) {
            addCriterion("LOG_TYPE not between", value1, value2, "logType");
            return (Criteria) this;
        }

        public Criteria andFileNameIsNull() {
            addCriterion("FILE_NAME is null");
            return (Criteria) this;
        }

        public Criteria andFileNameIsNotNull() {
            addCriterion("FILE_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andFileNameEqualTo(String value) {
            addCriterion("FILE_NAME =", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotEqualTo(String value) {
            addCriterion("FILE_NAME <>", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameGreaterThan(String value) {
            addCriterion("FILE_NAME >", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameGreaterThanOrEqualTo(String value) {
            addCriterion("FILE_NAME >=", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLessThan(String value) {
            addCriterion("FILE_NAME <", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLessThanOrEqualTo(String value) {
            addCriterion("FILE_NAME <=", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLike(String value) {
            addCriterion("FILE_NAME like", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotLike(String value) {
            addCriterion("FILE_NAME not like", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameIn(List<String> values) {
            addCriterion("FILE_NAME in", values, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotIn(List<String> values) {
            addCriterion("FILE_NAME not in", values, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameBetween(String value1, String value2) {
            addCriterion("FILE_NAME between", value1, value2, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotBetween(String value1, String value2) {
            addCriterion("FILE_NAME not between", value1, value2, "fileName");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNull() {
            addCriterion("SAMPLE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIsNotNull() {
            addCriterion("SAMPLE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSampleTimeEqualTo(Date value) {
            addCriterion("SAMPLE_TIME =", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <>", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThan(Date value) {
            addCriterion("SAMPLE_TIME >", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME >=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThan(Date value) {
            addCriterion("SAMPLE_TIME <", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeLessThanOrEqualTo(Date value) {
            addCriterion("SAMPLE_TIME <=", value, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeIn(List<Date> values) {
            addCriterion("SAMPLE_TIME in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotIn(List<Date> values) {
            addCriterion("SAMPLE_TIME not in", values, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME between", value1, value2, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andSampleTimeNotBetween(Date value1, Date value2) {
            addCriterion("SAMPLE_TIME not between", value1, value2, "sampleTime");
            return (Criteria) this;
        }

        public Criteria andLogFromIsNull() {
            addCriterion("LOG_FROM is null");
            return (Criteria) this;
        }

        public Criteria andLogFromIsNotNull() {
            addCriterion("LOG_FROM is not null");
            return (Criteria) this;
        }

        public Criteria andLogFromEqualTo(String value) {
            addCriterion("LOG_FROM =", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromNotEqualTo(String value) {
            addCriterion("LOG_FROM <>", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromGreaterThan(String value) {
            addCriterion("LOG_FROM >", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromGreaterThanOrEqualTo(String value) {
            addCriterion("LOG_FROM >=", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromLessThan(String value) {
            addCriterion("LOG_FROM <", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromLessThanOrEqualTo(String value) {
            addCriterion("LOG_FROM <=", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromLike(String value) {
            addCriterion("LOG_FROM like", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromNotLike(String value) {
            addCriterion("LOG_FROM not like", value, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromIn(List<String> values) {
            addCriterion("LOG_FROM in", values, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromNotIn(List<String> values) {
            addCriterion("LOG_FROM not in", values, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromBetween(String value1, String value2) {
            addCriterion("LOG_FROM between", value1, value2, "logFrom");
            return (Criteria) this;
        }

        public Criteria andLogFromNotBetween(String value1, String value2) {
            addCriterion("LOG_FROM not between", value1, value2, "logFrom");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelIsNull() {
            addCriterion("MCU_LOG_LEVEL is null");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelIsNotNull() {
            addCriterion("MCU_LOG_LEVEL is not null");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelEqualTo(String value) {
            addCriterion("MCU_LOG_LEVEL =", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelNotEqualTo(String value) {
            addCriterion("MCU_LOG_LEVEL <>", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelGreaterThan(String value) {
            addCriterion("MCU_LOG_LEVEL >", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelGreaterThanOrEqualTo(String value) {
            addCriterion("MCU_LOG_LEVEL >=", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelLessThan(String value) {
            addCriterion("MCU_LOG_LEVEL <", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelLessThanOrEqualTo(String value) {
            addCriterion("MCU_LOG_LEVEL <=", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelLike(String value) {
            addCriterion("MCU_LOG_LEVEL like", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelNotLike(String value) {
            addCriterion("MCU_LOG_LEVEL not like", value, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelIn(List<String> values) {
            addCriterion("MCU_LOG_LEVEL in", values, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelNotIn(List<String> values) {
            addCriterion("MCU_LOG_LEVEL not in", values, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelBetween(String value1, String value2) {
            addCriterion("MCU_LOG_LEVEL between", value1, value2, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andMcuLogLevelNotBetween(String value1, String value2) {
            addCriterion("MCU_LOG_LEVEL not between", value1, value2, "mcuLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelIsNull() {
            addCriterion("AI_LOG_LEVEL is null");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelIsNotNull() {
            addCriterion("AI_LOG_LEVEL is not null");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelEqualTo(String value) {
            addCriterion("AI_LOG_LEVEL =", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelNotEqualTo(String value) {
            addCriterion("AI_LOG_LEVEL <>", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelGreaterThan(String value) {
            addCriterion("AI_LOG_LEVEL >", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelGreaterThanOrEqualTo(String value) {
            addCriterion("AI_LOG_LEVEL >=", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelLessThan(String value) {
            addCriterion("AI_LOG_LEVEL <", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelLessThanOrEqualTo(String value) {
            addCriterion("AI_LOG_LEVEL <=", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelLike(String value) {
            addCriterion("AI_LOG_LEVEL like", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelNotLike(String value) {
            addCriterion("AI_LOG_LEVEL not like", value, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelIn(List<String> values) {
            addCriterion("AI_LOG_LEVEL in", values, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelNotIn(List<String> values) {
            addCriterion("AI_LOG_LEVEL not in", values, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelBetween(String value1, String value2) {
            addCriterion("AI_LOG_LEVEL between", value1, value2, "aiLogLevel");
            return (Criteria) this;
        }

        public Criteria andAiLogLevelNotBetween(String value1, String value2) {
            addCriterion("AI_LOG_LEVEL not between", value1, value2, "aiLogLevel");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}